<template>
  <div class="item-list">
    <div class="content-left">
      <div class="image-container">
        <nuxt-link
          class="ava"
          :to="'/' + product.shared_url + '?option=' + product.sku"
        >
          <img
            v-if="product.thumbnail != null"
            :src="resizeImage(baseImageUrl + product.thumbnail, 208, 208)"
            alt="product image"
          />
          <img
            v-else
            src="/images/placeholder/placeholder.svg"
            alt="product image"
          />
        </nuxt-link>
        <div v-if="product.status" class="product-label">
          <span class="label label-new">Mới về</span>
          <span class="label label-comming">Đang về</span>
          <span class="label label-sale">-25%</span>
        </div>
      </div>
    </div>
    <div class="content-center d-flex flex-column">
      <div v-if="product.status" class="time-action">Còn 5 ngày</div>
      <div class="name">
        <nuxt-link :to="'/' + product.shared_url + '?option=' + product.sku">
          {{ product.name }}
        </nuxt-link>
      </div>
      <div v-if="product.sku" class="code">SKU: {{ product.sku }}</div>

      <div v-if="product.options" class="changer_color mt-auto">
        <ul>
          <li
            v-for="(option, index) in product.options"
            :key="index"
            :class="index === 0 ? 'active' : ''"
          >
            <a href="javascript:;">
              <img
                :src="resizeImage(baseImageUrl + option.thumbnail, 300, 300)"
              />
            </a>
          </li>
        </ul>
      </div>
      <div class="content-more">
        <div v-if="product.option_name" class="desc-global">
          <!-- eslint-disable-next-line vue/no-v-html -->
          <div v-html="product.option_name"></div>
        </div>
      </div>
    </div>
    <div class="content-right">
      <div class="product-price">
        <div class="price">
          <strong>
            {{ (product.sale_price || product.price) | formatNumber }}
          </strong>
        </div>
        <div v-if="product.sale_from_price" class="price_old">
          {{ product.from_price | formatNumber }}
        </div>
      </div>
      <div class="more_btn">
        <a
          class="btn-default color-white add-cart"
          href="javascript:;"
          @click="addToCart(product)"
        >
          Thêm vào giỏ hàng
        </a>
        <!-- <a
          class="btn-default white add-compare"
          href="javascript:;"
          @click="addToCompare(product)"
        >
          Thêm vào so sánh
        </a> -->
      </div>
    </div>
  </div>
</template>

<script>
import Helper from '../../assets/config'

export default {
  name: 'SmallProductList',
  // eslint-disable-next-line vue/require-prop-types
  props: ['product'],
  data() {
    return {}
  },
  computed: {
    baseImageUrl() {
      return Helper.baseImageUrl
    },
    compares() {
      return this.$store.state.compares
    },
  },
  methods: {
    resizeImage(url, width, height) {
      return Helper.resizeImage(url, width, height)
    },
    addToCart(product) {
      this.$store.commit('add', product)
    },
    addToCompare(product) {
      const found = this.compares.some((el) => el.sku === product.sku)
      if (!found) {
        this.$axios.$get('/option/type/' + product.sku).then((type) => {
          if (this.compares.length === 4) {
            alert('Bạn không thể so sánh lớn hơn 4 sản phẩm !')
            return
          }
          if (type !== 'phu-kien') {
            product.type = type
            this.$store.commit('addcompare', product)
          } else {
            alert('Những sản phẩm phụ kiện không hỗ trợ so sánh!')
          }
        })
      } else {
        alert('Sản phẩm đã được thêm vào danh sách so sánh!')
      }
    },
  },
}
</script>
